# 术语表

- [术语表](#%e6%9c%af%e8%af%ad%e8%a1%a8)
  - [概述](#%e6%a6%82%e8%bf%b0)
  - [术语和定义](#%e6%9c%af%e8%af%ad%e5%92%8c%e5%ae%9a%e4%b9%89)

----

## 概述

本文档将维护和持续更新Rosetta框架中出现的各种术语和缩写。

## 术语和定义

- **安全多方计算 (MPC)**
一种密码学协议。可以在多方参与下共同进行函数计算，计算结束后各自得到结果，整个过程中不会额外泄漏除结果之外的信息。

- **零知识证明 (ZKP)**
一种密码学协议。包含证明者和验证者两个参与方，证明者可以向验证者证明某个论断是正确的，而不泄漏其他额外的信息。

- **同态加密 (HE)**
一种密码学算法。将数据进行加密后得到密文，任何人可以在密文上进行操作，并且将相应的操作映射到明文上。

- **联邦学习（FL）**
一种人工智能算法。多方联合进行建模，通过多方同步中间权重梯度的方法，最终训练得到模型。

- **可信执行环境（TEE）**
由硬件创造的安全区域。它保证了装载在里面的代码的运行和数据的机密性和完整性。

- **秘密分享（SS）**
一种安全多方计算协议。通过将隐私的数据，包括中间值随机的分成两份或者多份，每一份由各个参与方拥有。单独的每一份不会泄漏数据的任何信息。

- **优化遍（Pass）**
是编译器的组成部分，在Rosetta中用作TensorFlow原生算子与隐私算子的替换和优化。
- **静态优化遍（Static Pass）**
一种优化遍，在Rosetta中，用于替换执行前的有向图（静态图）。
- **动态优化遍（Dynamic Pass）**
一种优化遍，在Rosetta中，用于在执行时替换有向图。
